// mktdm.cs
// An example objlib script to create a DM/TDM mission's core objects.

exec("objlib.cs");

$x = 0;
$y = 0;
%id = getObjectId("MissionGroup/NavOmega");
if (%id) {
	// if NavOmega exists it defines center of all bases
	$x = getPosition(%id,x);
	$y = getPosition(%id,y);
}

$z = -10000; // -10000 means object z is relative to terrain height
$radius = 300; // distance from each base to origin

function Base(%t,%x,%y,%z,%r) {
	objsetteam(%t);
	objsetorigin(%x,%y,%z,%r);
	%color = objgetteamcolor();
	%id = objsimshapegroup(0,objgetteambase());
	lobj(%id,"NavPoint","ESNavMarker_Nav"@%color,"",0,0,-1,0);
	lobj(%id,"HealTrigger","SimTrigger_"@%color@"Heal","",-100,0,0,0);
	nobj(%id,"HealPad",StaticInterior,"hHeallite.dis",-100,0,0,0);
	lobj(%id,"HealGen","StaticShape_"@%color@"HealGenLite","",-69,31,0,45);
	lobj(%id,"AmmoTrigger","SimTrigger_"@%color@"Ammo","", 100,0,0,0);
	nobj(%id,"AmmoPad",StaticInterior,"hAmmolite.dis", 100,0,0,0);
	lobj(%id,"AmmoGen","StaticShape_"@%color@"AmmoGenLite","", 69,31,0,135);
	%dpgid = objdpgroup();
	objdpline(%dpgid,12,25,0,-50,0,0);
}

// DM drop points
objsetteam(0);
objsetorigin($x,$y,$z,0);
objdpcircle(%dpgid,12,40,0,0,0,0);

Base(1,$x,$y-$radius,$z,0);
Base(2,$x+$radius,$y,$z,90);
Base(3,$x-$radius,$y,$z,-90);
Base(4,$x,$y+$radius,$z,180);
