// mktest.cs
// An example objlib script to build a complete DM/TDM or CTF mission.

exec("objlib.cs");

objsetverbosity(0);

// Set to 1 to make a CTF mission, 0 for DM/TDM
$ctf = 1;

// NavOmega created by hand, defines center of all bases
$x = getPosition("MissionGroup/NavOmega",x);
$y = getPosition("MissionGroup/NavOmega",y);
$z = -10000; // -10000 means object z is relative to terrain height
$radius = 250;

function Base(%t,%x,%y,%z,%r) {
	objsetteam(%t);
	objsetorigin(%x,%y,%z,%r);
	%color = objgetteamcolor();
	%id = objsimshapegroup(0,objgetteambase());

	lobj(%id,"NavPoint","ESNavMarker_Nav"@%color,"",0,10,-1,0);

	if ($ctf && ((%t==2) || (%t==4))) {
		// CTF flags only for Blue and Purple
		lobj(%id,%color@"Flag","StaticShape_"@%color@"Flag","",0,10,0,0);
		lobj(%id,%color@"FlagTrigger","SimTrigger_"@%color@"Flag","",0,10,5,0);
	}

	lobj(%id,"HealTrigger","SimTrigger_"@%color@"Heal","",-100,-205,0,0);
	lobj(%id,"AmmoTrigger","SimTrigger_"@%color@"Ammo","", 100,-205,0,0);
	nobj(%id,"HealPad",StaticInterior,"hHeallite.dis",-100,-205,0,0);
	nobj(%id,"AmmoPad",StaticInterior,"hAmmolite.dis", 100,-205,0,0);
	lobj(%id,"HealGen","StaticShape_"@%color@"HealGenLite","",-78,-274,-6,90);
	lobj(%id,"AmmoGen","StaticShape_"@%color@"AmmoGenLite","", 78,-274,-6,90);

	nobj(%id,"LGate",StaticInterior,"hbigcastlet.dis",-150,-100,-3,90);
	nobj(%id,"RGate",StaticInterior,"hbigcastlet.dis", 150,-100,-3,90);
	nobj(%id,"LFWall",StaticInterior,"hwallhuge.dis",-50,0,0,270);
	nobj(%id,"RFWall",StaticInterior,"hwallhuge.dis", 50,0,0,180);
	nobj(%id,"LRAWall",StaticInterior,"hwallhuge.dis",-110,-215,0,0);
	nobj(%id,"RRAWall",StaticInterior,"hwallhuge.dis", 110,-215,0,90);
	nobj(%id,"LRBWall",StaticInterior,"hwallhuge.dis",-50,-315,0,0);
	nobj(%id,"RRBWall",StaticInterior,"hwallhuge.dis", 50,-315,0,90);

	nobj(%id,"Roof",StaticInterior,"hbridgev.dis",0,20,-14,90);

	nobj(%id,"Flagbuilding1",StaticInterior,"hflagbuild.dis",0,195,-5,0);

	%dpgid = objdpgroup();
	objdpbox(%dpgid,4,3,22,22,0,-310,0,0);
}

objsetteam(0);
objsetorigin($x,$y,$z,0);

%id = objsimshapegroup(0,"Zen");
nobj(%id,"ZenPad",StaticInterior,"hZendark.dis",0,0,0,0);
lobj(%id,"ZenTrigger","SimTrigger_YellowZen","",0,0,0,0);

if (!$ctf) {
	// DM drop points
	%dpgid = objdpgroup();
	objdpcircle(%dpgid,12,690,0,0,0,0);
}

if ($ctf) {
	Base(1,$x+$radius,$y,$z,90);
	Base(2,$x,$y-$radius,$z,0);
} else {
	Base(1,$x,$y-$radius,$z,0);
	Base(2,$x+$radius,$y,$z,90);
}
Base(3,$x-$radius,$y,$z,-90);
Base(4,$x,$y+$radius,$z,180);
