// objlib.cs
// Author: [OF]Pincushion
// Last modified: 7 July 2001
//
// Defines functions for programmatic Starsiege mission creation.
// Documentation is in objlib.html.
// Visit http://www.geocities.com/SoHo/Nook/9351/maps/ for more stuff.

focusServer();

$objversion = "objlib 0.0";

// $sine[] table courtesy MIB Sentinal's TrigonometryStdlib.cs

// Returns sine of angle %a (degrees)
function sin(%a) {
	while (%a < 0) %a += 360;
	%a = floor(%a+0.5);
	while (%a > 360) %a -= 360;
	if ((%a >= 0) && (%a < 90)) {
		%sin = $sine[%a];
	} else if ((%a >= 90) && (%a < 180)) {
		%sin = $sine[180-%a];
	} else if ((%a >= 180) && (%a < 270)) {
		%sin = -$sine[%a-180];
	} else {
		%sin = -$sine[360-%a];
	}
	return %sin;
}

// Returns cosine of angle %a (degrees)
function cos(%a) {
	return sin(90-%a);
}

$sine[0] = 0;
$sine[1] = 0.017452;
$sine[2] = 0.034899;
$sine[3] = 0.052335;
$sine[4] = 0.069756;
$sine[5] = 0.087156;
$sine[6] = 0.104528;
$sine[7] = 0.121869;
$sine[8] = 0.139173;
$sine[9] = 0.156434;
$sine[10] = 0.173648;
$sine[11] = 0.190809;
$sine[12] = 0.207912;
$sine[13] = 0.224951;
$sine[14] = 0.241922;
$sine[15] = 0.258819;
$sine[16] = 0.275637;
$sine[17] = 0.292372;
$sine[18] = 0.309017;
$sine[19] = 0.325568;
$sine[20] = 0.342020;
$sine[21] = 0.358368;
$sine[22] = 0.374607;
$sine[23] = 0.390731;
$sine[24] = 0.406737;
$sine[25] = 0.422618;
$sine[26] = 0.438371;
$sine[27] = 0.453990;
$sine[28] = 0.469472;
$sine[29] = 0.484810;
$sine[30] = 0.5;
$sine[31] = 0.515038;
$sine[32] = 0.529919;
$sine[33] = 0.544639;
$sine[34] = 0.559193;
$sine[35] = 0.573576;
$sine[36] = 0.587785;
$sine[37] = 0.601815;
$sine[38] = 0.615661;
$sine[39] = 0.629320;
$sine[40] = 0.642788;
$sine[41] = 0.656059;
$sine[42] = 0.669131;
$sine[43] = 0.681998;
$sine[44] = 0.694658;
$sine[45] = 0.707107;
$sine[46] = 0.719340;
$sine[47] = 0.731354;
$sine[48] = 0.743145;
$sine[49] = 0.754710;
$sine[50] = 0.766044;
$sine[51] = 0.777146;
$sine[52] = 0.788011;
$sine[53] = 0.798636;
$sine[54] = 0.809017;
$sine[55] = 0.819152;
$sine[56] = 0.829038;
$sine[57] = 0.838671;
$sine[58] = 0.848048;
$sine[59] = 0.857167;
$sine[60] = 0.866025;
$sine[61] = 0.874620;
$sine[62] = 0.882948;
$sine[63] = 0.891007;
$sine[64] = 0.898794;
$sine[65] = 0.906308;
$sine[66] = 0.913545;
$sine[67] = 0.920505;
$sine[68] = 0.927184;
$sine[69] = 0.933580;
$sine[70] = 0.939693;
$sine[71] = 0.945519;
$sine[72] = 0.951057;
$sine[73] = 0.956305;
$sine[74] = 0.961262;
$sine[75] = 0.965926;
$sine[76] = 0.970296;
$sine[77] = 0.974370;
$sine[78] = 0.978148;
$sine[79] = 0.981627;
$sine[80] = 0.984808;
$sine[81] = 0.987688;
$sine[82] = 0.990268;
$sine[83] = 0.992546;
$sine[84] = 0.994522;
$sine[85] = 0.996195;
$sine[86] = 0.997564;
$sine[87] = 0.998630;
$sine[88] = 0.999391;
$sine[89] = 0.999848;
$sine[90] = 1;

$objv = 0;
$objt = 0;
$objx = 0;
$objy = 0;
$objz = -10000;
$objr = 0;

$TeamSym[0] = "Neutral";
$TeamSym[1] = *IDSTR_TEAM_YELLOW;
$TeamSym[2] = *IDSTR_TEAM_BLUE;
$TeamSym[3] = *IDSTR_TEAM_RED;
$TeamSym[4] = *IDSTR_TEAM_PURPLE;
function objgetteamsym() {return $TeamSym[$objt];}

$TeamBase[0] = "Base";
$TeamBase[1] = "yellowBase";
$TeamBase[2] = "blueBase";
$TeamBase[3] = "redBase";
$TeamBase[4] = "purpleBase";
function objgetteambase() {return $TeamBase[$objt];}

$TeamColor[0] = "Neutral";
$TeamColor[1] = "Yellow";
$TeamColor[2] = "Blue";
$TeamColor[3] = "Red";
$TeamColor[4] = "Purple";
function objgetteamcolor() {return $TeamColor[$objt];}

$objlogfn = "";
function objsetlogfn(%fn) {
	$objlogfn = %fn;
	if ($objlogfn != "") {
		objmsg("Logging output to "@$objlogfn);
		$objtitle = "Log for "@$objversion@", "@getDate()@", "@getTime();
		export("$objtitle",$objlogfn,overwrite);
	}
}
function objgetlogfn() {return $objlogfn;}

function objmsg(%v,%msg) {
	if ($objlogfn != "")
		fileWrite($objlogfn,append,%msg);
	if (%v<=$objv)
		echo("OBJ: "@%msg);
}

function objsetverbosity(%v) {$objv = %v;}
function objgetverbosity() {return $objv;}

function objsetteam(%t) {$objt = %t;}
function objgetteam() {return $objt;}

function objsetorigin(%x,%y,%z,%r) {
	$objx = %x;
	$objy = %y;
	$objz = %z;
	$objr = %r;
}
function objsetx(%x) {$objx = %x;}
function objgetx() {return $objx;}
function objsety(%y) {$objy = %y;}
function objgety() {return $objy;}
function objsetz(%z) {$objz = %z;}
function objgetz() {return $objz;}
function objsetr(%r) {$objr = %r;}
function objgetr() {return $objr;}

function xobj(%xid,%id,%name,%type,%dx,%dy,%dz,%dr) {
	if (%xid == 0) return 0;
	%sin = sin($objr);
	%cos = cos($objr);
	%rx = %dx * %cos - %dy * %sin;
	%ry = %dx * %sin + %dy * %cos;
	if ($objz == -10000)
		%z = getTerrainHeight($objx,$objy);
	else
		%z = $objz;
	%a = $objr+%dr;
	setPosition(%xid,$objx+%rx,$objy+%ry,%z+%dz,%a);
	addToSet(%id,%xid);
	%msg = %msg@"Created "@getFullPath(%xid);
	%msg = %msg@" id="@%xid;
	%msg = %msg@" a="@%a;
	//%msg = %msg@" sin="@%sin;
	//%msg = %msg@" cos="@%cos;
	%msg = %msg@" dx="@%dx;
	%msg = %msg@" dy="@%dy;
	%msg = %msg@" rx="@%rx;
	%msg = %msg@" ry="@%ry;
	objmsg(1,%msg);
	if ($objt) {
		// Note: setTeam() doesn't stick to some objects
		setTeam(%xid,objgetteamsym());
	}
	return %xid;
}

function objchk(%id,%name) {
	%nm = getFullPath(%id)@"\\"@%name;
	%xid = getObjectId(%nm);
	if (%xid == 0) return 0;
	//if (!isObject(%nm)) return;
	objmsg(1,%nm@" already exists.");
	return %xid;
}

function lobj(%id,%name,%type,%shape,%dx,%dy,%dz,%dr) {
	%xid = objchk(%id,%name);
	if (%xid) return %xid;
	%fn = "obj/Obj_"@%type@".dat";
	if (!isFile(%fn)) {
		objmsg(0,"Can't create "@%type@", "@%fn@" doesn't exist.");
		return 0;
	}
	%xid = loadObject(%name,%fn);
	return xobj(%xid,%id,%name,%type,%dx,%dy,%dz,%dr);
}

function nobj(%id,%name,%type,%shape,%dx,%dy,%dz,%dr) {
	%xid = objchk(%id,%name);
	if (%xid) return %xid;
	%xid = newObject(%name,%type,%shape);
	return xobj(%xid,%id,%name,%type,%dx,%dy,%dz,%dr);
}

function svobj(%id,%type) {
	focusServer();
	%fn = "Obj_"@%type@".dat";
	storeObject(%id,%fn);
}

function objsimgroup(%id,%name) {
	if (%id == 0)
		%id = getObjectId("MissionGroup");
	%id = nobj(%id,%name,SimGroup,"",0,0,0,0);
	return %id;
}

function objsimshapegroup(%id,%name) {
	if (%id == 0)
		%id = getObjectId("MissionGroup");
	%id = nobj(%id,%name,SimShapeGroup,"",0,0,0,0);
	return %id;
}

function objdpgroup() {
	%id = getObjectId("MissionGroup");
	%t = objgetteam();
	if (%t == 0) %t = "";
	%id = nobj(%id,"DropPointGroup"@%t,ESDropPointGroup,"",0,0,0,0);
	return %id;
}

function objdp(%dpgid,%k,%dx,%dy,%dz,%dr) {
	%id = lobj(%dpgid,"D"@%k,SimDropPoint,"",%dx,%dy,%dz,%dr);
	return %id;
}

function objdpline(%dpgid,%n,%g,%dx,%dy,%dz,%dr) {
	if (%n<=0) return;
	if (%dpgid == 0) return;
	%uy = %dy;
	for (%k=1;%k<=%n;%k++) {
		%ux = %dx+(%k-1-((%n-1)/2.0))*%g;
		objdp(%dpgid,%k,%ux,%uy,%dz,%dr);
	}
	return(%k-1);
}

function objdpbox(%dpgid,%nc,%nr,%gc,%gr,%dx,%dy,%dz,%dr) {
	if ((%nc<=0)||(%nr<=0)) return;
	if (%dpgid == 0) return;
	%k = 1;
	for (%row=0;%row<%nr;%row++) {
		%uy = %dy+(%row-((%nr-1)/2.0))*%gr;
		for (%col=0;%col<%nc;%col++) {
			%ux = %dx+(%col-((%nc-1)/2.0))*%gc;
			objdp(%dpgid,%k,%ux,%uy,%dz,%dr);
			%k++;
		}
	}
	return(%k-1);
}

function objdpcircle(%dpgid,%n,%rad,%dx,%dy,%dz,%dr) {
	if (%n<=0) return;
	if (%dpgid == 0) return;
	for (%k=1;%k<=%n;%k++) {
		%a = (%k-1)*(360/%n);
		%ux = %dx+%rad*cos(%a);
		%uy = %dy+%rad*sin(%a);
		//echo("a="@%a@" cos="@cos(%a)@" sin="@sin(%a)@" x,y="@%ux@","@%uy);
		%dr = 90+%a;
		%id = objdp(%dpgid,%k,%ux,%uy,%dz,%dr);
	}
	return(%k-1);
}

echo($objversion@" loaded.");
